<% local view, viewlibrary, pageinfo, session = ... %>
<% require("viewfunctions") %>

<% --[[ DEBUG INFORMATION
io.write(html.cfe_unpack(view))
--]] %>

<link rel="stylesheet" type="text/css" href="/js/style.css">
<script type="text/javascript" src="/js/jquery-latest.js"></script>
<script type="text/javascript" src="/js/jquery.tablesorter.min.js"></script>
<script type="text/javascript">
	$(document).ready(function() {
		$("#pending").tablesorter({headers: {0:{sorter: false}}});
		$("#approved").tablesorter({headers: {0:{sorter: false}, 5:{sorter:'usLongDate'}}});
		$("#revoked").tablesorter({headers: {0:{sorter: false}, 5:{sorter:'usLongDate'}}});
	});
</script>

<% displaycommandresults({"approve", "deleterequest", "deletemyrequest", "renewcert", "requestrenewcert", "revoke", "deletecert"}, session) %>

<H1>Pending certificate requests<% if view.value.user then%> for <%= html.html_escape(view.value.user.value) %><% end %></H1>
<% if not view.value.pending or #view.value.pending.value == 0 then %>
	No certificates pending
<% else %>
<table id="pending" class="tablesorter">
<thead>
	<tr>
		<th>Action</th>
		<th>User</th>
		<th>Cert Type</th>
		<th>Common Name</th>
	</tr>
</thead>
<tbody>
	<% for i,request in ipairs(view.value.pending.value) do %>
		<tr>
		<td>
		<% if session.permissions.openssl.viewrequest then
			io.write(html.link{value="viewrequest?request="..request.name, label="View "})
		end %>
		<% if session.permissions.openssl.approve then
			io.write(html.link{value="approve?request="..request.name, label="Approve "})
		end %>
		<% if session.permissions.openssl.deleterequest then
			io.write(html.link{value="deleterequest?request="..request.name, label="Delete "})
		elseif session.permissions.openssl.deletemyrequest then
			io.write(html.link{value="deletemyrequest?request="..request.name, label="Delete "})
		end %>
		</td>
		<td><%= html.html_escape(request.user) %></td>
		<td><%= html.html_escape(request.certtype) %></td>
		<td><%= html.html_escape(request.commonName) %></td>
		</tr>
	<% end %>
</tbody>
</table>
<% end %>

<% local reverserevoked = {}
local approved = {}
local revoked = {}
if view.value.revoked and #view.value.revoked.value > 0 then
	for i,serial in ipairs(view.value.revoked.value) do
		reverserevoked[serial] = i
	end
	for i,cert in ipairs(view.value.approved.value) do
		if reverserevoked[cert.serial] then
			revoked[#revoked + 1] = cert
		else
			approved[#approved + 1] = cert
		end
	end
else
	approved = view.value.approved.value
end %>
	
<H1>Approved certificate requests<% if view.value.user then%> for <%= html.html_escape(view.value.user.value) %><% end %></H1>
<% if #approved == 0 then %>
	No certificates approved
<% else %>
<table id="approved" class="tablesorter">
<thead>
	<tr>
		<th>Action</th>
		<th>User</th>
		<th>Cert Type</th>
		<th>Common Name</th>
		<th>Serial Num</th>
		<th>End Date</th>
	</tr>
</thead>
<tbody>
	<% for i,cert in ipairs(approved) do %>
		<tr <% if cert.daysremaining < 14 then %>class='error'<% end %>>
		<td>
		<% if session.permissions.openssl.viewcert then %>
			<%= html.link{value="viewcert?cert="..cert.name, label="View "} %>
		<% end %>
		<% if session.permissions.openssl.getcert then %>
			<%= html.link{value="getcert?cert="..cert.name, label="Download "} %>
		<% end %>
		<% if session.permissions.openssl.renewcert then %>
			<%= html.link{value="renewcert?cert="..cert.name, label="Renew "} %>
		<% elseif session.permissions.openssl.requestrenewcert then %>
			<%= html.link{value="requestrenewcert?cert="..cert.name, label="Renew "} %>
		<% end %>
		<% if session.permissions.openssl.revoke then %>
			<%= html.link{value="revoke?cert="..cert.name, label="Revoke "} %>
		<% end %>
		<% if session.permissions.openssl.deletecert then %>
			<%= html.link{value="deletecert?cert="..cert.name, label="Delete "} %>
		<% end %>
		</td>
		<td><%= html.html_escape(cert.user) %></td>
		<td><%= html.html_escape(cert.certtype) %></td>
		<td><%= html.html_escape(cert.commonName) %></td>
		<td><%= html.html_escape(tostring(tonumber('0x'..cert.serial))) %></td>
		<td><%= html.html_escape(cert.enddate) %></td>
		</tr>
	<% end %>
<tbody>
</table>
<% end %>

<H1>Revoked certificates<% if view.value.user then%> for <%= html.html_escape(view.value.user.value) %><% end %></H1>
<% if #revoked == 0 then %>
	No certificates revoked
<% else %>
<table id="revoked" class="tablesorter">
<thead>
	<tr>
		<th>Action</th>
		<th>User</th>
		<th>Cert Type</th>
		<th>Common Name</th>
		<th>Serial Num</th>
	</tr>
</thead>
<tbody>
	<% for i,cert in ipairs(revoked) do %>
		<tr>
		<td>
		<% if session.permissions.openssl.viewcert then %>
			<%= html.link{value="viewcert?cert="..cert.name, label="View "} %>
		<% end %>
		<% --[[ if session.permissions.openssl.getcert then %>
			<%= html.link{value="getcert?cert="..cert.name, label="Download "} %>
		<% end --]] %>
		<% if session.permissions.openssl.deletecert then %>
			<%= html.link{value="deletecert?cert="..cert.name, label="Delete "} %>
		<% end %>
		</td>
		<td><%= html.html_escape(cert.user) %></td>
		<td><%= html.html_escape(cert.certtype) %></td>
		<td><%= html.html_escape(cert.commonName) %></td>
		<td><%= html.html_escape(tostring(tonumber('0x'..cert.serial))) %></td>
		</tr>
	<% end %>
</tbody>
</table>
<% end %>

<% if session.permissions.openssl.getrevoked then %>
<H1>Get revoked list (crl)</H1>
<%= html.link{value="getrevoked?crltype=PEM", label="Download PEM "} %><BR>
<%= html.link{value="getrevoked?crltype=DER", label="Download DER "} %><BR>
<%= html.link{value="getrevoked", label="Import to Firefox"} %><BR>

<% end %>
